package cz.uhk.mikesji3.centrality;

import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.SparseMultigraph;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import cz.uhk.mikesji3.centrality.gui.Gui;
import cz.uhk.mikesji3.centrality.model.Edge;

public class App {
	
    Graph<Integer, Integer> g;
    int verticesCount;
    int edgesCount;
    List<Edge> edgeList;
    
    public App() {
        verticesCount = 5;
        edgesCount = 8;
    }
    
	public static void main(String[] args) {
        App sgv = new App();
        new Gui(sgv);
    }
	
	public void buildRandomGraph(){
        g = new SparseMultigraph<Integer, Integer>();
        addVertices(verticesCount);
        addEdges(edgesCount, verticesCount);
	}
    
    private void addVertices(int verticesCount) {
    	for(int i = 1; i < verticesCount+1;i++){
    		g.addVertex((Integer)i); 
    	}
	}

	private void addEdges(int edgesCount, int verticesCount) {
		edgeList = new ArrayList<Edge>();
    	for(int i = 1; i < edgesCount+1;i++){
    		Random random = new Random();
    		int v1 = random.nextInt(verticesCount)+1;
    		boolean fullVertex = true;
    		while(fullVertex){
    			v1 = random.nextInt(verticesCount)+1;
    			if(g.getNeighborCount(v1)<verticesCount-1){
    				fullVertex=false;
    			}
    		}
    		int v2 = random.nextInt(verticesCount)+1;
    		boolean tryAgain = true;
    		while(tryAgain){
    			v2 = random.nextInt(verticesCount)+1;
    			if(v1!=v2 && !g.isNeighbor(v1, v2)){
    				tryAgain=false;
    			}
    		}
    		g.addEdge(i+100, v1, v2);
    		edgeList.add(new Edge(v1,v2));
    	}
	}
	
	public Graph<Integer, Integer> getG(){
		return g;
	}
	
	public void setVerticesCount(int verticesCount){
		this.verticesCount = verticesCount;
	}
	
	public void setEdgesCount(int edgesCount){
		this.edgesCount = edgesCount;
	}
	
	public int getEdgesCount(){
		return edgesCount;
	}
	
	public int getVerticesCount(){
		return verticesCount;
	}
	
	public List<Edge> getEdgeList(){
		return this.edgeList;
	}

	public void buildGraph(int verticesCount2, List<Edge> edgeList) {
		verticesCount = verticesCount2;
		edgesCount = edgeList.size();
		this.edgeList = edgeList;
		g = new SparseMultigraph<Integer, Integer>();
        addVertices(verticesCount);
        for(int i = 1; i < edgeList.size()+1; i++){
        	g.addEdge(i+100, edgeList.get(i-1).getVertex1(), edgeList.get(i-1).getVertex2());
        }
	}
    
}