package cz.uhk.mikesji3.centrality.algorithms;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

import edu.uci.ics.jung.graph.Graph;

public class ShortestPaths {
	
	Graph<Integer, Integer> g;
	
	public ShortestPaths(Graph<Integer, Integer> g){
		this.g = g;
	}

	public List<List<Integer>> getAllPaths(int source, int target) {
		List<List<Integer>> shPaths = new ArrayList<List<Integer>>();
		boolean[] flag = new boolean[g.getVertexCount()+1];
		List<int[]> parentList = new ArrayList<int[]>();
		for(int i = 0; i<g.getVertexCount()+1;i++){
			flag[i]=false;
		}
		List<Integer> prevList = new ArrayList<Integer>();
		List<Integer> currentList = new ArrayList<Integer>();
		Queue<Integer> Q = new LinkedList<Integer>();
		Q.add(currentList.size());
		prevList.add(0);
		currentList.add(source);
		int[] prev1 = new int[g.getVertexCount()+1];
		parentList.add(prev1);
		while (!Q.isEmpty()) {
			int number = Q.remove();
			Integer v = currentList.get(number);
			flag[v] = true;
			if (v == target) {
				break;
			} else {
				for (Integer w : g.getNeighbors(v)) {
					if (flag[w] == false) {
						if(w==target){
							List<Integer> directions = new LinkedList<Integer>();
					        directions.add(target);
							for(Integer node = v; node != 0; node = parentList.get(number)[node]) {
								directions.add(node);
						    }
							shPaths.add(directions);
						}else{
							Q.add(currentList.size());
							prevList.add(v);
							currentList.add(w);
							int[] prev2 = new int[parentList.get(number).length];
							for(int i=0;i<parentList.get(number).length;i++){
								prev2[i] = Integer.valueOf(parentList.get(number)[i]);
							}
							prev2[w] = v;
							parentList.add(prev2);
						}
					}
				}
			}
		}
		return shPaths;
	}

	public List<List<Integer>> getShPathsThru(int i, int j, int x) {
		List<List<Integer>> shPathsThru = new ArrayList<List<Integer>>();
		List<List<Integer>> shPaths = getShPaths(i, j);
		for(int k = 0; k < shPaths.size(); k++){
			List<Integer> path = shPaths.get(k);
			for (int l = 0; l < path.size(); l++) {
				if (path.get(l)==x) {
					shPathsThru.add(shPaths.get(k));
				}
			}
		}
		return shPathsThru;
	}

	public List<List<Integer>> getShPaths(int source, int target) {
		List<List<Integer>> shPaths = new ArrayList<List<Integer>>();
		List<List<Integer>> allPaths = getAllPaths(source, target);
		int minPathLength = 1000;
		for(int i=0;i<allPaths.size();i++){
			if(allPaths.get(i).size()<minPathLength){
				minPathLength=allPaths.get(i).size();
			}
		}
		for(int i=0;i<allPaths.size();i++){
			if(allPaths.get(i).size()==minPathLength){
				shPaths.add(allPaths.get(i));
			}
		}
		return shPaths;
	}
	
	public int getShPathLength(int source, int target){
		int shPathLength = -1;
		if(getShPaths(source, target).size()>0){
			shPathLength = getShPaths(source, target).get(0).size()-1;
		}
		return shPathLength;
	}
}
