package cz.uhk.mikesji3.centrality.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;

public class ControlsFrame extends JFrame {

	private static final long serialVersionUID = 1L;
	JLabel lbHint;
	JButton button;
	Gui gui;

	public ControlsFrame(Gui gui, Point point) {
		setTitle("Nápověda");
		this.gui = gui;
		setPreferredSize(new Dimension(550, 180));
		setLocation(new Point(point.x + 37, point.y + 200));

		lbHint = new JLabel(
				"<html>Přidávat hrany je možné tažením z jednoho vrcholu na druhý při stlačeném pravém tlačítku myši.<br><br>Vybranou hranu je možné smazat klávesou DELETE.<br><br>Textový soubor pro import grafu musí mít na prvním řádku číslo znázorňující počet vrcholů. Následující řádky obsahují každý jednu hranu ve tvaru vrchol1-vrchol2 (např. 3-5).</html>");
		getContentPane().add(lbHint, BorderLayout.NORTH);

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				ControlsFrame.this.gui.setEnabled(true);
				dispose();
			}
		});

		button = new JButton("OK");
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				ControlsFrame.this.gui.setEnabled(true);
				dispose();
			}
		});
		getContentPane().add(button, BorderLayout.SOUTH);

		pack();
		setVisible(true);
	}

}
