package cz.uhk.mikesji3.centrality.gui;

import java.awt.Dimension;
import java.awt.Label;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class KatzParameterFrame extends JFrame {

	private static final long serialVersionUID = 1L;
	
	Gui gui;
	Label label;
	JButton buttonOK;
	JButton btCancel;
	JSlider slParameter;
	Label lbValue;
	CentralityBox cb;
	JPanel pnButtons;
	JPanel pnSlider;

	public KatzParameterFrame(Gui gui, CentralityBox cb, Point location){
		this.gui = gui;
		this.cb = cb;
		setTitle("Nastavení parametru");
		setPreferredSize(new Dimension(300,180));
		setLocation(new Point(location.x+180,location.y+140));
		
		JPanel listPane = new JPanel();
		listPane.setLayout(new BoxLayout(listPane, BoxLayout.PAGE_AXIS));
		listPane.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e){
				KatzParameterFrame.this.gui.setEnabled(true);
			}
		});
		
		label = new Label("Zadejte parametr k");
		listPane.add(label);
		
		slParameter = new JSlider(JSlider.HORIZONTAL,0, 100, 50);
		slParameter.setValue(50);
		ChangeListener lstPrameter = new ChangeListener() {
			public void stateChanged(ChangeEvent arg0) {
				lbValue.setText(((float)slParameter.getValue()/100)+"");
			}
		};
		slParameter.addChangeListener(lstPrameter);
		pnSlider = new JPanel();
		pnSlider.add(slParameter);
		
		lbValue = new Label("0.5");
		pnSlider.add(lbValue);
		listPane.add(pnSlider);
		
		buttonOK = new JButton("OK");
		buttonOK.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				KatzParameterFrame.this.cb.calculateKatz((float)slParameter.getValue()/100);
				KatzParameterFrame.this.gui.setEnabled(true);
				dispose();
			}
		});
		pnButtons = new JPanel();
		pnButtons.add(buttonOK);
		
		btCancel = new JButton("Zrušit");
		btCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				KatzParameterFrame.this.gui.setEnabled(true);
				dispose();
			}
		});
		pnButtons.add(btCancel);
		listPane.add(pnButtons);
		
		getContentPane().add(listPane);
		pack();
		setVisible(true);
	}
	
}
