package cz.uhk.mikesji3.centrality.measures;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import cz.uhk.mikesji3.centrality.model.Vertex;

import edu.uci.ics.jung.graph.Graph;

public class AbstractMeasure {
	
	Graph<Integer, Integer> g;
	List<Vertex> vertices;

	public AbstractMeasure(Graph<Integer, Integer> g) {
		this.g = g;
		prepareVertices(g);
	}
	
	private void prepareVertices(Graph<Integer, Integer> g) {
		vertices = new ArrayList<Vertex>();
		Collection<Integer> integerList = g.getVertices();
		for (int i = 0; i < integerList.size(); i++) {
			vertices.add(new Vertex(i+1));
		}
	}
	
	public void calculateRank(int type) {
		float array[] = new float[vertices.size()];
		for (int i = 0; i < vertices.size(); i++) {
			array[i] = vertices.get(i).getCentrality(type);
		}

		for (int i = 0; i < array.length - 1; i++) {
			for (int j = 0; j < array.length - i - 1; j++) {
				if (array[j] < array[j + 1]) {
					float tmp = array[j];
					array[j] = array[j + 1];
					array[j + 1] = tmp;
				}
			}
		}
		
		for (int i = 0; i < vertices.size(); i++) {
			for (int j = 0; j < array.length; j++) {
				if(vertices.get(i).getCentrality(type)==array[j]){
					vertices.get(i).setRank(j+1,type);
					break;
				}
			}
		}
	}

	public List<Vertex> getVertices() {
		return vertices;
	}
}
