package cz.uhk.mikesji3.centrality.measures;

import cz.uhk.mikesji3.centrality.algorithms.ShortestPaths;
import edu.uci.ics.jung.graph.Graph;

public class BetweennessC extends AbstractMeasure implements IMeasure {
	
	ShortestPaths sp;

	public BetweennessC(Graph<Integer, Integer> g) {
		super(g);
		sp = new ShortestPaths(g);
	}

	public void calculate() {
		for (int x = 0; x < vertices.size(); x++) {
			float betweenness = 0;
			for (int i = 0; i < vertices.size(); i++) {
				if (i != x) {
					for (int j = 0; j < i; j++) {
						if (j != x) {
							float ratio = 0;
							int iVertexId = vertices.get(i).getId();
							int jVertexId = vertices.get(j).getId();
							int xVertexId = vertices.get(x).getId();
							float ijx = sp.getShPathsThru(iVertexId, jVertexId, xVertexId).size();
							float ij = sp.getShPaths(iVertexId, jVertexId).size();
							if (ij != 0) {
								ratio = ijx / ij;
							}
							betweenness = betweenness + ratio;
						}
					}
				}
			}
			float r = (float) Math.round(betweenness * 100) / 100;
			vertices.get(x).setCentrality(r, 2); // 2 = betweenness centrality
		}
	}
}
