package cz.uhk.mikesji3.centrality.measures;

import cz.uhk.mikesji3.centrality.algorithms.ShortestPaths;
import edu.uci.ics.jung.graph.Graph;

public class ClosenessC extends AbstractMeasure implements IMeasure{
	
	ShortestPaths sp;

	public ClosenessC(Graph<Integer, Integer> g) {
		super(g);
		sp = new ShortestPaths(g);
	}

	public void calculate() {
		for (int i = 0; i < vertices.size(); i++) {
			int totalDistance = 0;
			int iVertexId = vertices.get(i).getId();
			for (int j = 0; j < vertices.size(); j++) {
				if(i!=j){
					int jVertexId = vertices.get(j).getId();
					if(sp.getShPathLength(iVertexId, jVertexId)!=-1){
						totalDistance = totalDistance + sp.getShPathLength(iVertexId, jVertexId);
					}
				}
			}
			if (totalDistance > 0) {
				float n = (float) 1 / totalDistance;
				float r = (float) Math.round(n * 100) / 100;
				vertices.get(i).setCentrality(r, 1); //1 = closeness
			}
			else{
				vertices.get(i).setCentrality(0, 1); //1 = closeness
			}
		}
	}
}
